require 'thor'

module S3Rsync
  class CLI < Thor
      
    def self.common_opts
      method_option :path, :aliases => "-p", :required => true
      method_option :'config-path', :aliases => "-c", :required => true
      method_option :'s3-prefix', :aliases => "-s", :default => 's3rsync'
      method_option :'log-path', :aliases => "-l"
      method_option :'dry-run', :aliases => "-d", :type => :boolean, :default => false
      method_option :'make-public', :aliases => "-m", :type => :boolean, :default => false
      method_option :'enable-lock', :aliases => "-e", :type => :boolean, :default => false
    end
    
    desc "upload", "sync from local to s3"
    common_opts
    def upload
      require 's3rsync/sync'
      sync = Sync.new(options)
      exit sync.run(:upload)
    end
    
    desc "download", "sync from s3 to local"
    common_opts
    def download
      require 's3rsync/sync'
      sync = Sync.new(options)
      exit sync.run(:download)
    end
    
  end
  
end
